#include <avr/io.h>
#include <util/delay.h>

#define DELAY_SECVENTA		250
#define NUM_SECVENTE		6

#define DURATA_NOTA		100

#define NUM_NOTE		8

int frecventa_nota[NUM_NOTE] = {2096.00, 2349.32, 2537.02, 2793.83, 3135.96, 3520.00, 3951.07, 4186.01};

/* Initializare ADC */
void ADC_init(void)
{
    ADMUX = (1 << REFS0);
    ADCSRA = (1 << ADEN) | (5 << ADPS0);
}

/* Conversia valorii de la ADC. */
int ADC_get(uint8_t channel)
{
    ADMUX = (ADMUX & ~(0x1f << MUX0)) | channel;

    ADCSRA |= (1 << ADSC);
    while(ADCSRA & (1 << ADSC));

    return ADC;
}

/* Genereaza o nota folosind buzzer-ul. */
void speaker_reda(int nota) {
	float perioada_nota = 100000 / frecventa_nota[nota];
	int i, j;
	int x;

	/* durata mai scurta pentru notele foarte joase */
	if (perioada_nota > 1000)
		x = 10;
	else
		x = DURATA_NOTA;
		for (i = 0; i < x; i++) {
			PORTD ^= (1 << PD5);

			for (j = 0; j < perioada_nota / 2; ++j)
				_delay_us(1);

			PORTD ^= (1 << PD5);

			//for (j = 0 ; j < perioada_nota / 2; ++j)
			//	_delay_us(1);
			
		}
}


/*
 * Genereaza note folosind buzzer-ul. La detectarea unei intreruperi 
 * a razei, se va aprinde si ledul legat la PD7.
 */
void sing(void) {
	
	/* Initializare ADC. */
	ADC_init();
	
	/* Setez pinul buzzerului si ledul ca iesire. */
	DDRD |= (1 << PD5) | (1 << PD7) ;

	/* Opresc buzzer-ul. */
	PORTD ^= (1 << PD5);
	
	int i;
	_delay_us(1000);
	while (1) {
		/* 
		 * Daca s-a intrerupt un laser, canta nota respectiva si
		 * aprinde ledul.
		 */
		for (i = 0; i < 8; i++) {
			int val = ADC_get(i);
			if (val > 400){
				PORTD |= (1 << PD7);
				speaker_reda(i);
			}
			PORTD &= ~(1 << PD7);
		}
	}
}

int main(void) {
	sing();

	while (1);

	return 0;
}
